Index: /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 79397)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 79398)
@@ -34,4 +34,5 @@
 #include <QStyle>
 #include <QStackedWidget>
+#include <QTableWidget>
 #include <QToolButton>
 #include <QXmlStreamReader>
@@ -491,5 +492,5 @@
     /** Is called when the captions in UISoftKeyboardKey is changed and forward this changes to
       * corresponding UISoftKeyboardLayout */
-    void updateKeyCaptionsInLayout(UISoftKeyboardKey *pKey);
+    //void updateKeyCaptionsInLayout(UISoftKeyboardKey *pKey);
     void saveCurentLayoutToFile();
     void copyCurentLayout();
@@ -688,7 +689,7 @@
     void prepareObjects();
 
-    QCheckBox  *m_pShowNumPadCheckBox;
-    QCheckBox  *m_pShowOsMenuButtonsCheckBox;
-
+    QCheckBox   *m_pShowNumPadCheckBox;
+    QCheckBox   *m_pShowOsMenuButtonsCheckBox;
+    QTableWidget *m_pColorSelectionTable;
 };
 
@@ -2059,17 +2060,17 @@
 }
 
-void UISoftKeyboardWidget::updateKeyCaptionsInLayout(UISoftKeyboardKey *pKey)
-{
-    if (!m_pCurrentKeyboardLayout || !pKey)
-        return;
-
-    /* Assuming the key captions are changed for the current layout: */
-    KeyCaptions newCaptions;
-    // newCaptions.m_strBase = pKey->baseCaption();
-    // newCaptions.m_strShift = pKey->shiftCaption();
-    // newCaptions.m_strAltGr = pKey->altGrCaption();
-    // newCaptions.m_strShiftAltGr = pKey->shiftAltGrCaption();
-    m_pCurrentKeyboardLayout->updateKeyCaptions(pKey->position(), newCaptions);
-}
+// void UISoftKeyboardWidget::updateKeyCaptionsInLayout(UISoftKeyboardKey *pKey)
+// {
+//     if (!m_pCurrentKeyboardLayout || !pKey)
+//         return;
+
+//     /* Assuming the key captions are changed for the current layout: */
+//     KeyCaptions newCaptions;
+//     // newCaptions.m_strBase = pKey->baseCaption();
+//     // newCaptions.m_strShift = pKey->shiftCaption();
+//     // newCaptions.m_strAltGr = pKey->altGrCaption();
+//     // newCaptions.m_strShiftAltGr = pKey->shiftAltGrCaption();
+//     m_pCurrentKeyboardLayout->updateKeyCaptions(pKey->position(), newCaptions);
+// }
 
 void UISoftKeyboardWidget::addLayout(const UISoftKeyboardLayout &newLayout)
@@ -2327,5 +2328,5 @@
     m_iInitialWidthNoNumPad = qMax(m_iInitialWidthNoNumPad, iInitialWidthNoNumPad);
     m_iInitialHeight = qMax(m_iInitialHeight, iInitialHeight);
-    //printf("%s total key count: %d\n", qPrintable(strLayoutFileName), iKeyCount - 3 /* substract OS an menu keys */);
+
     return true;
 }
@@ -2887,4 +2888,5 @@
     , m_pShowNumPadCheckBox(0)
     , m_pShowOsMenuButtonsCheckBox(0)
+    , m_pColorSelectionTable(0)
 {
     prepareObjects();
@@ -2920,13 +2922,19 @@
     m_pShowOsMenuButtonsCheckBox = new QCheckBox;
 
-    pSettingsLayout->addWidget(m_pShowNumPadCheckBox, 0, 0);
-    pSettingsLayout->addWidget(m_pShowOsMenuButtonsCheckBox, 1, 0);
+    pSettingsLayout->addWidget(m_pShowNumPadCheckBox, 0, 0, 1, 1);
+    pSettingsLayout->addWidget(m_pShowOsMenuButtonsCheckBox, 1, 0, 1, 1);
 
     connect(m_pShowNumPadCheckBox, &QCheckBox::toggled, this, &UISoftKeyboardSettingsWidget::sigShowNumPad);
     connect(m_pShowOsMenuButtonsCheckBox, &QCheckBox::toggled, this, &UISoftKeyboardSettingsWidget::sigShowOSMenuKeys);
 
+    m_pColorSelectionTable = new QTableWidget;
+    pSettingsLayout->addWidget(m_pShowOsMenuButtonsCheckBox, 2, 0, 2, 1);
+    m_pColorSelectionTable->setRowCount(3);
+    m_pColorSelectionTable->setColumnCount(2);
+
+
     QSpacerItem *pSpacer = new QSpacerItem(0, 0, QSizePolicy::Expanding, QSizePolicy::Expanding);
     if (pSpacer)
-        pSettingsLayout->addItem(pSpacer, 2, 0);
+        pSettingsLayout->addItem(pSpacer, 4, 0);
 
     setLayout(pSettingsLayout);
@@ -3060,9 +3068,7 @@
 void UISoftKeyboard::sltKeyCaptionsEdited(UISoftKeyboardKey* pKey)
 {
+    Q_UNUSED(pKey);
     if (m_pKeyboardWidget)
-    {
-        m_pKeyboardWidget->updateKeyCaptionsInLayout(pKey);
         m_pKeyboardWidget->update();
-    }
 }
 