Index: /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 79512)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 79513)
@@ -771,8 +771,8 @@
     {
         KeyCaptions captions = m_pLayout->keyCaptions(m_pKey->position());
+        if (captions.m_strBase != m_pBaseCaptionEdit->text())
+            m_pLayout->setBaseCaption(m_pKey->position(), m_pBaseCaptionEdit->text());
         if (captions.m_strShift != m_pShiftCaptionEdit->text())
             m_pLayout->setShiftCaption(m_pKey->position(), m_pShiftCaptionEdit->text());
-        if (captions.m_strBase != m_pBaseCaptionEdit->text())
-            m_pLayout->setShiftCaption(m_pKey->position(), m_pBaseCaptionEdit->text());
         if (captions.m_strAltGr != m_pAltGrCaptionEdit->text())
             m_pLayout->setAltGrCaption(m_pKey->position(), m_pAltGrCaptionEdit->text());
@@ -1977,4 +1977,6 @@
                 else
                     ledColor = QColor(255, 50, 50);
+                if (m_enmMode == Mode_LayoutEdit)
+                    ledColor = color(KeyboardColorType_Font);
                 painter.setBrush(ledColor);
                 painter.setPen(ledColor);
@@ -1983,5 +1985,4 @@
             }
             painter.translate(-key.keyGeometry().x(), -key.keyGeometry().y());
-
         }
     }
Index: /trunk/src/VBox/Frontends/VirtualBox/xml/brazilian.xml
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/xml/brazilian.xml	(revision 79512)
+++ /trunk/src/VBox/Frontends/VirtualBox/xml/brazilian.xml	(revision 79513)
@@ -3,9 +3,9 @@
     <name>Brazilian (ABNT)</name>
     <nativename>Brasil</nativename>
-    <id>e207bfc4-2a6f-4d9c-a1ef-8e80841dadf2</id>
     <physicallayoutid>{a6ee5425-ad96-43e2-96ac-0d148cb73802}</physicallayoutid>
+    <id>{eb78d388-1305-4904-8f13-2923dcc121bc}</id>
     <key>
         <position>110</position>
-        <basecaption></basecaption>
+        <basecaption>Esc</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -14,5 +14,5 @@
     <key>
         <position>112</position>
-        <basecaption></basecaption>
+        <basecaption>F1</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -21,5 +21,5 @@
     <key>
         <position>113</position>
-        <basecaption></basecaption>
+        <basecaption>F2</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -28,5 +28,5 @@
     <key>
         <position>114</position>
-        <basecaption></basecaption>
+        <basecaption>F3</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -35,5 +35,5 @@
     <key>
         <position>115</position>
-        <basecaption></basecaption>
+        <basecaption>F4</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -42,5 +42,5 @@
     <key>
         <position>116</position>
-        <basecaption></basecaption>
+        <basecaption>F5</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -49,5 +49,5 @@
     <key>
         <position>117</position>
-        <basecaption></basecaption>
+        <basecaption>F6</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -56,5 +56,5 @@
     <key>
         <position>188</position>
-        <basecaption></basecaption>
+        <basecaption>F7</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -63,5 +63,5 @@
     <key>
         <position>119</position>
-        <basecaption></basecaption>
+        <basecaption>F8</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -70,5 +70,5 @@
     <key>
         <position>120</position>
-        <basecaption></basecaption>
+        <basecaption>F9</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -77,5 +77,5 @@
     <key>
         <position>121</position>
-        <basecaption></basecaption>
+        <basecaption>F10</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -84,5 +84,5 @@
     <key>
         <position>122</position>
-        <basecaption></basecaption>
+        <basecaption>F11</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -91,5 +91,5 @@
     <key>
         <position>123</position>
-        <basecaption></basecaption>
+        <basecaption>F12</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -98,6 +98,6 @@
     <key>
         <position>124</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
+        <basecaption>PrtScr</basecaption>
+        <shiftcaption>SysRq</shiftcaption>
         <altgrcaption></altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
@@ -105,5 +105,6 @@
     <key>
         <position>125</position>
-        <basecaption></basecaption>
+        <basecaption>Scroll
+Lock</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -112,5 +113,6 @@
     <key>
         <position>126</position>
-        <basecaption></basecaption>
+        <basecaption>Pause
+Break</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -119,6 +121,6 @@
     <key>
         <position>1</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
+        <basecaption>'</basecaption>
+        <shiftcaption>&quot;</shiftcaption>
         <altgrcaption></altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
@@ -126,48 +128,48 @@
     <key>
         <position>2</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>1</basecaption>
+        <shiftcaption>!</shiftcaption>
+        <altgrcaption>¹</altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>3</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>2</basecaption>
+        <shiftcaption>@</shiftcaption>
+        <altgrcaption>²</altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>4</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>3</basecaption>
+        <shiftcaption>#</shiftcaption>
+        <altgrcaption>³</altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>5</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>4</basecaption>
+        <shiftcaption>$</shiftcaption>
+        <altgrcaption>£</altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>6</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>5</basecaption>
+        <shiftcaption>%</shiftcaption>
+        <altgrcaption>¢</altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>7</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>6</basecaption>
+        <shiftcaption>‥</shiftcaption>
+        <altgrcaption>¬</altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>8</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
+        <basecaption>7</basecaption>
+        <shiftcaption>&amp;</shiftcaption>
         <altgrcaption></altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
@@ -175,6 +177,6 @@
     <key>
         <position>9</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
+        <basecaption>8</basecaption>
+        <shiftcaption>*</shiftcaption>
         <altgrcaption></altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
@@ -182,6 +184,6 @@
     <key>
         <position>10</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
+        <basecaption>9</basecaption>
+        <shiftcaption>(</shiftcaption>
         <altgrcaption></altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
@@ -189,6 +191,6 @@
     <key>
         <position>11</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
+        <basecaption>0</basecaption>
+        <shiftcaption>)</shiftcaption>
         <altgrcaption></altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
@@ -196,6 +198,6 @@
     <key>
         <position>12</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
+        <basecaption>-</basecaption>
+        <shiftcaption>_</shiftcaption>
         <altgrcaption></altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
@@ -203,12 +205,12 @@
     <key>
         <position>13</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>=</basecaption>
+        <shiftcaption>+</shiftcaption>
+        <altgrcaption>§</altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>15</position>
-        <basecaption></basecaption>
+        <basecaption>Backspace</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -217,5 +219,5 @@
     <key>
         <position>75</position>
-        <basecaption></basecaption>
+        <basecaption>Insert</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -224,5 +226,5 @@
     <key>
         <position>80</position>
-        <basecaption></basecaption>
+        <basecaption>Home</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -231,5 +233,6 @@
     <key>
         <position>85</position>
-        <basecaption></basecaption>
+        <basecaption>Page
+Up</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -238,5 +241,6 @@
     <key>
         <position>90</position>
-        <basecaption></basecaption>
+        <basecaption>Num
+Lock</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -245,5 +249,5 @@
     <key>
         <position>95</position>
-        <basecaption></basecaption>
+        <basecaption>/</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -252,5 +256,5 @@
     <key>
         <position>100</position>
-        <basecaption></basecaption>
+        <basecaption>*</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -259,5 +263,5 @@
     <key>
         <position>105</position>
-        <basecaption></basecaption>
+        <basecaption>-</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -266,5 +270,5 @@
     <key>
         <position>16</position>
-        <basecaption></basecaption>
+        <basecaption>Tab</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -273,26 +277,26 @@
     <key>
         <position>17</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>Q</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption>/</altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>18</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>W</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption>?</altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>19</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>E</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption>€ </altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>20</position>
-        <basecaption></basecaption>
+        <basecaption>R</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -301,5 +305,5 @@
     <key>
         <position>21</position>
-        <basecaption></basecaption>
+        <basecaption>T</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -308,5 +312,5 @@
     <key>
         <position>22</position>
-        <basecaption></basecaption>
+        <basecaption>Y</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -315,5 +319,5 @@
     <key>
         <position>23</position>
-        <basecaption></basecaption>
+        <basecaption>U</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -322,5 +326,5 @@
     <key>
         <position>24</position>
-        <basecaption></basecaption>
+        <basecaption>I</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -329,5 +333,5 @@
     <key>
         <position>25</position>
-        <basecaption></basecaption>
+        <basecaption>O</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -336,5 +340,5 @@
     <key>
         <position>26</position>
-        <basecaption></basecaption>
+        <basecaption>P</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -343,6 +347,6 @@
     <key>
         <position>27</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
+        <basecaption>´</basecaption>
+        <shiftcaption>`</shiftcaption>
         <altgrcaption></altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
@@ -350,12 +354,12 @@
     <key>
         <position>28</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>[</basecaption>
+        <shiftcaption>{</shiftcaption>
+        <altgrcaption>ª</altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>43</position>
-        <basecaption></basecaption>
+        <basecaption>Enter</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -364,5 +368,5 @@
     <key>
         <position>76</position>
-        <basecaption></basecaption>
+        <basecaption>Delete</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -371,5 +375,5 @@
     <key>
         <position>81</position>
-        <basecaption></basecaption>
+        <basecaption>End</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -378,5 +382,6 @@
     <key>
         <position>86</position>
-        <basecaption></basecaption>
+        <basecaption>Page
+Down</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -385,5 +390,5 @@
     <key>
         <position>91</position>
-        <basecaption></basecaption>
+        <basecaption>7</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -392,5 +397,5 @@
     <key>
         <position>96</position>
-        <basecaption></basecaption>
+        <basecaption>8</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -399,5 +404,5 @@
     <key>
         <position>101</position>
-        <basecaption></basecaption>
+        <basecaption>9</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -406,5 +411,5 @@
     <key>
         <position>106</position>
-        <basecaption></basecaption>
+        <basecaption>+</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -413,5 +418,5 @@
     <key>
         <position>30</position>
-        <basecaption></basecaption>
+        <basecaption>Caps Lock</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -420,5 +425,5 @@
     <key>
         <position>31</position>
-        <basecaption></basecaption>
+        <basecaption>A</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -427,5 +432,5 @@
     <key>
         <position>32</position>
-        <basecaption></basecaption>
+        <basecaption>S</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -434,5 +439,5 @@
     <key>
         <position>33</position>
-        <basecaption></basecaption>
+        <basecaption>D</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -441,5 +446,5 @@
     <key>
         <position>34</position>
-        <basecaption></basecaption>
+        <basecaption>F</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -448,5 +453,5 @@
     <key>
         <position>35</position>
-        <basecaption></basecaption>
+        <basecaption>G</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -455,5 +460,5 @@
     <key>
         <position>36</position>
-        <basecaption></basecaption>
+        <basecaption>H</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -462,5 +467,5 @@
     <key>
         <position>37</position>
-        <basecaption></basecaption>
+        <basecaption>J</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -469,5 +474,5 @@
     <key>
         <position>38</position>
-        <basecaption></basecaption>
+        <basecaption>K</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -476,5 +481,5 @@
     <key>
         <position>39</position>
-        <basecaption></basecaption>
+        <basecaption>L</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -483,5 +488,5 @@
     <key>
         <position>40</position>
-        <basecaption></basecaption>
+        <basecaption>Ç</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -490,6 +495,6 @@
     <key>
         <position>41</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
+        <basecaption>~</basecaption>
+        <shiftcaption>^</shiftcaption>
         <altgrcaption></altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
@@ -497,12 +502,12 @@
     <key>
         <position>42</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>]</basecaption>
+        <shiftcaption>}</shiftcaption>
+        <altgrcaption>º</altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>92</position>
-        <basecaption></basecaption>
+        <basecaption>4</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -511,5 +516,5 @@
     <key>
         <position>97</position>
-        <basecaption></basecaption>
+        <basecaption>5</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -518,5 +523,5 @@
     <key>
         <position>102</position>
-        <basecaption></basecaption>
+        <basecaption>6</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -525,5 +530,5 @@
     <key>
         <position>44</position>
-        <basecaption></basecaption>
+        <basecaption>Shift</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -532,6 +537,6 @@
     <key>
         <position>45</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
+        <basecaption>\</basecaption>
+        <shiftcaption>|</shiftcaption>
         <altgrcaption></altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
@@ -539,5 +544,5 @@
     <key>
         <position>46</position>
-        <basecaption></basecaption>
+        <basecaption>Z</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -546,5 +551,5 @@
     <key>
         <position>47</position>
-        <basecaption></basecaption>
+        <basecaption>X</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -553,12 +558,12 @@
     <key>
         <position>48</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>C</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption>₢</altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>49</position>
-        <basecaption></basecaption>
+        <basecaption>V</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -567,5 +572,5 @@
     <key>
         <position>50</position>
-        <basecaption></basecaption>
+        <basecaption>B</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -574,5 +579,5 @@
     <key>
         <position>51</position>
-        <basecaption></basecaption>
+        <basecaption>N</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -581,5 +586,5 @@
     <key>
         <position>52</position>
-        <basecaption></basecaption>
+        <basecaption>M</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -588,6 +593,6 @@
     <key>
         <position>53</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
+        <basecaption>,</basecaption>
+        <shiftcaption>&lt;</shiftcaption>
         <altgrcaption></altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
@@ -595,6 +600,6 @@
     <key>
         <position>54</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
+        <basecaption>.</basecaption>
+        <shiftcaption>&gt;</shiftcaption>
         <altgrcaption></altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
@@ -602,6 +607,6 @@
     <key>
         <position>55</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
+        <basecaption>;</basecaption>
+        <shiftcaption>:</shiftcaption>
         <altgrcaption></altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
@@ -609,6 +614,6 @@
     <key>
         <position>56</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
+        <basecaption>/</basecaption>
+        <shiftcaption>?</shiftcaption>
         <altgrcaption></altgrcaption>
         <shiftaltgrcaption></shiftaltgrcaption>
@@ -616,5 +621,5 @@
     <key>
         <position>57</position>
-        <basecaption></basecaption>
+        <basecaption>Shift</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -623,5 +628,5 @@
     <key>
         <position>83</position>
-        <basecaption></basecaption>
+        <basecaption>↑</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -630,5 +635,5 @@
     <key>
         <position>93</position>
-        <basecaption></basecaption>
+        <basecaption>1</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -637,5 +642,5 @@
     <key>
         <position>98</position>
-        <basecaption></basecaption>
+        <basecaption>2</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -644,5 +649,5 @@
     <key>
         <position>103</position>
-        <basecaption></basecaption>
+        <basecaption>3</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -651,5 +656,5 @@
     <key>
         <position>108</position>
-        <basecaption></basecaption>
+        <basecaption>Enter</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -658,5 +663,5 @@
     <key>
         <position>58</position>
-        <basecaption></basecaption>
+        <basecaption>Ctrl</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -665,5 +670,5 @@
     <key>
         <position>227</position>
-        <basecaption></basecaption>
+        <basecaption>OS</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -672,5 +677,5 @@
     <key>
         <position>60</position>
-        <basecaption></basecaption>
+        <basecaption>Alt</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -686,5 +691,5 @@
     <key>
         <position>62</position>
-        <basecaption></basecaption>
+        <basecaption>AltGr</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -693,5 +698,5 @@
     <key>
         <position>231</position>
-        <basecaption></basecaption>
+        <basecaption>OS</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -700,5 +705,5 @@
     <key>
         <position>129</position>
-        <basecaption></basecaption>
+        <basecaption>Menu</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -707,5 +712,5 @@
     <key>
         <position>64</position>
-        <basecaption></basecaption>
+        <basecaption>Ctrl</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -714,5 +719,5 @@
     <key>
         <position>79</position>
-        <basecaption></basecaption>
+        <basecaption>←</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -721,5 +726,5 @@
     <key>
         <position>84</position>
-        <basecaption></basecaption>
+        <basecaption>↓</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -728,5 +733,5 @@
     <key>
         <position>89</position>
-        <basecaption></basecaption>
+        <basecaption>→</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -735,5 +740,5 @@
     <key>
         <position>99</position>
-        <basecaption></basecaption>
+        <basecaption>0</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
@@ -742,5 +747,5 @@
     <key>
         <position>104</position>
-        <basecaption></basecaption>
+        <basecaption>.</basecaption>
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>