Index: /trunk/src/VBox/NetworkServices/Dhcpd/Db.cpp
===================================================================
--- /trunk/src/VBox/NetworkServices/Dhcpd/Db.cpp	(revision 79529)
+++ /trunk/src/VBox/NetworkServices/Dhcpd/Db.cpp	(revision 79530)
@@ -369,5 +369,5 @@
  * @param   id          The client ID.
  */
-Binding *Db::createBinding(const ClientId &id)
+Binding *Db::i_createBinding(const ClientId &id)
 {
     Binding      *pBinding = NULL;
@@ -400,5 +400,5 @@
  * @param   id          The client.
  */
-Binding *Db::createBinding(RTNETADDRIPV4 addr, const ClientId &id)
+Binding *Db::i_createBinding(RTNETADDRIPV4 addr, const ClientId &id)
 {
     bool fAvailable = m_pool.allocate(addr);
@@ -423,5 +423,5 @@
  * the preferred address (@a addr) into account when possible and if non-zero.
  */
-Binding *Db::allocateAddress(const ClientId &id, RTNETADDRIPV4 addr)
+Binding *Db::i_allocateAddress(const ClientId &id, RTNETADDRIPV4 addr)
 {
     Assert(addr.u == 0 || addressBelongs(addr));
@@ -503,5 +503,5 @@
         if (addrBinding == NULL)
         {
-            addrBinding = createBinding(addr, id);
+            addrBinding = i_createBinding(addr, id);
             Assert(addrBinding != NULL);
             LogDHCP(("> .... creating new binding for this address %R[binding]\n", addrBinding));
@@ -529,5 +529,5 @@
     else
     {
-        idBinding = createBinding();
+        idBinding = i_createBinding();
         if (idBinding != NULL)
             LogDHCP(("> .... creating new binding\n"));
@@ -586,5 +586,5 @@
     const ClientId &id(req.clientId());
 
-    Binding *b = allocateAddress(id, reqAddr.value());
+    Binding *b = i_allocateAddress(id, reqAddr.value());
     if (b != NULL)
     {
@@ -607,7 +607,7 @@
  *
  * @returns IPRT status code.
- * @param   newb                .
- */
-int Db::addBinding(Binding *pNewBinding)
+ * @param   pNewBinding     The new binding to add.
+ */
+int Db::i_addBinding(Binding *pNewBinding)
 {
     /*
@@ -841,5 +841,5 @@
         if (pElmLease->nameEquals("Lease"))
         {
-            int rc2 = loadLease(pElmLease);
+            int rc2 = i_loadLease(pElmLease);
             if (RT_SUCCESS(rc2))
             { /* likely */ }
@@ -863,5 +863,5 @@
  * @return  IPRT status code.
  */
-int Db::loadLease(const xml::ElementNode *pElmLease)
+int Db::i_loadLease(const xml::ElementNode *pElmLease)
 {
     Binding *pBinding = NULL;
@@ -882,5 +882,5 @@
             LogDHCP(("> LOAD: EXPIRED lease %R[binding]\n", pBinding));
 
-        int rc = addBinding(pBinding);
+        int rc = i_addBinding(pBinding);
         if (RT_FAILURE(rc))
             delete pBinding;
Index: /trunk/src/VBox/NetworkServices/Dhcpd/Db.h
===================================================================
--- /trunk/src/VBox/NetworkServices/Dhcpd/Db.h	(revision 79529)
+++ /trunk/src/VBox/NetworkServices/Dhcpd/Db.h	(revision 79530)
@@ -163,5 +163,5 @@
     int      loadLeases(const RTCString &strFilename);
 private:
-    int      loadLease(const xml::ElementNode *pElmLease);
+    int      i_loadLease(const xml::ElementNode *pElmLease);
 public:
     int      writeLeases(const RTCString &strFilename) const;
@@ -169,11 +169,11 @@
 
 private:
-    Binding *createBinding(const ClientId &id = ClientId());
-    Binding *createBinding(RTNETADDRIPV4 addr, const ClientId &id = ClientId());
+    Binding *i_createBinding(const ClientId &id = ClientId());
+    Binding *i_createBinding(RTNETADDRIPV4 addr, const ClientId &id = ClientId());
 
-    Binding *allocateAddress(const ClientId &id, RTNETADDRIPV4 addr);
+    Binding *i_allocateAddress(const ClientId &id, RTNETADDRIPV4 addr);
 
     /* add binding e.g. from the leases file */
-    int      addBinding(Binding *b);
+    int      i_addBinding(Binding *pNewBinding);
 };
 
Index: /trunk/src/VBox/NetworkServices/Dhcpd/DhcpdInternal.h
===================================================================
--- /trunk/src/VBox/NetworkServices/Dhcpd/DhcpdInternal.h	(revision 79529)
+++ /trunk/src/VBox/NetworkServices/Dhcpd/DhcpdInternal.h	(revision 79530)
@@ -16,6 +16,6 @@
  */
 
-#ifndef VBOX_INCLUDED_SRC_Dhcpd_Defs_h
-#define VBOX_INCLUDED_SRC_Dhcpd_Defs_h
+#ifndef VBOX_INCLUDED_SRC_Dhcpd_DhcpdInternal_h
+#define VBOX_INCLUDED_SRC_Dhcpd_DhcpdInternal_h
 #ifndef RT_WITHOUT_PRAGMA_ONCE
 # pragma once
@@ -72,3 +72,3 @@
 #endif
 
-#endif /* !VBOX_INCLUDED_SRC_Dhcpd_Defs_h */
+#endif /* !VBOX_INCLUDED_SRC_Dhcpd_DhcpdInternal_h */
Index: /trunk/src/VBox/NetworkServices/Dhcpd/Timestamp.h
===================================================================
--- /trunk/src/VBox/NetworkServices/Dhcpd/Timestamp.h	(revision 79529)
+++ /trunk/src/VBox/NetworkServices/Dhcpd/Timestamp.h	(revision 79530)
@@ -16,6 +16,6 @@
  */
 
-#ifndef VBOX_INCLUDED_SRC_Dhcpd_TimeStamp_h
-#define VBOX_INCLUDED_SRC_Dhcpd_TimeStamp_h
+#ifndef VBOX_INCLUDED_SRC_Dhcpd_Timestamp_h
+#define VBOX_INCLUDED_SRC_Dhcpd_Timestamp_h
 #ifndef RT_WITHOUT_PRAGMA_ONCE
 # pragma once
@@ -110,3 +110,3 @@
 inline bool operator>=(const Timestamp &l, const Timestamp &r) { return l.compare(r) >= 0; }
 
-#endif /* !VBOX_INCLUDED_SRC_Dhcpd_TimeStamp_h */
+#endif /* !VBOX_INCLUDED_SRC_Dhcpd_Timestamp_h */